
;//------. Winnt.h -------------

;// DWORD-  -
;//    3Ch    (DOS-)
;// http://www.sunshine2k.de/reversing/tuts/tut_pe.htm 

struct PE_HEADER
  Signature          dd  0   ;// 00   50450000 = 'PE..'
  Machine            dw  0   ;// 04   014C = Intel.386
  NumberOfSection    dw  0   ;// 06   -   
  TimeStamp          dd  0   ;// 08
  SymbolPointer      dd  0   ;// 12
  SymbolSize         dd  0   ;// 16
  SizeOfOptHeader    dw  0   ;// 20   00E0 =  "OPTIONAL HEADER"
  Flags              dw  0   ;// 22
;//--- OPTIONAL HEADER -------------------
  Magic              dw  0   ;// 24   010B = PE32 (020B = PE32+)
  LinkerVersion      dw  0   ;// 26
  SizeOfCode         dd  0   ;// 28
  SizeOfInitData     dd  0   ;// 32
  SizeOfUnInitData   dd  0   ;// 36
  EntryPointRVA      dd  0   ;// 40   -
  CodeBaseRVA        dd  0   ;// 44 
  DataBaseRVA        dd  0   ;// 48
  ImageBase          dd  0   ;// 52    
  SectionAlign       dd  0   ;// 56   
  FileAlign          dd  0   ;// 60
  OsVersion          dd  0   ;// 64
  ImageVersion       dd  0   ;// 68
  SubSysVersion      dd  0   ;// 72
  Reserved           dd  0   ;// 76
  SizeOfImage        dd  0   ;// 80
  SizeOfHeader       dd  0   ;// 84
  FileChecksum       dd  0   ;// 88
  SubSystem          dw  0   ;// 92
  DLLflags           dw  0   ;// 94
  SizeOfStackReserve dd  0   ;// 96
  SizeOfStackCommit  dd  0   ;// 100
  SizeOfHeapReserve  dd  0   ;// 104
  SizeOfHeapCommit   dd  0   ;// 108
  LoaderFlag         dd  0   ;// 112
  NumberOfDataDir    dd  0   ;// 116
;//--- DATA DIRECTORY --------------------
;//-- (   .data    ,       )
  Export             dd  0,0   ;// 120 ---> data 0
  Import             dd  0,0   ;// 128           1
  Resource           dd  0,0   ;// 136           2
  Exception          dd  0,0   ;// 144           3  --> i386  
  Security           dd  0,0   ;// 152           4             ,  1
  FixUp              dd  0,0   ;// 160           5
  Debug              dd  0,0   ;// 168           6
  Architecture       dd  0,0   ;// 176           7
  Global             dd  0,0   ;// 184           8  --> i386  
  TLS                dd  0,0   ;// 192           9
  LoadConfig         dd  0,0   ;// 200           10
  BoundImport        dd  0,0   ;// 208           11     ImportRVA(1)
  IAT                dd  0,0   ;// 216           12    IAT ( )
  DelayImport        dd  0,0   ;// 224           13  
  COMdescriptor      dd  0,0   ;// 232           14   .NET-
  Reserved1          dd  0,0   ;// 240 ---> data 15
ends

struct SECTION_TABLE   ;//<------------ 40  (28h)
  ObjectName         rb  8   ;// 248 (00)   
  VirtualSize        dd  0   ;// 256 (08)    
  VirtualAddr        dd  0   ;// 260 (12)  ..(  )
  RawSize            dd  0   ;// 264 (16)    
  RawAddr            dd  0   ;// 268 (20)  ..(  )
  Reserved           rb  12  ;// 272 (24)      EXE = 0
  SectionFlags       dd  0   ;// 284 (36)    
ends

;//------------------------------

struct IMAGE_IMPORT_DESCRIPTOR  ;    "DATA_DIRECTORY"
  OriginFirstThank   dd  0      ; OFT --> "Import Lookup RVA"
  TimeStamp          dd  0
  FotwardingChain    dd  0
  ModuleName         dd  0
  FirstThunk         dd  0      ; FTs --> "Import Address Table RVA"
ends

struct IMPORT_ADDRESS_TABLE     ;<----- FTs
  ImageThunkData     dd  0
ends  

struct IMPORT_LOOKUP_TABLE      ;<----- OFT
  ImageThunkData     dd  0      ; ! (31): 1=/0=
ends                            ;  ,      /

struct IMPORT_NAME_TABLE
  Hint               dw  0      ;  (  .  )
  FumctionName       db  ?      ; ASCII- 
  Padding            db  ?      ;   2- 
ends

;-----------------------------------
if 0
 IAT  Lookup   ,     . 
  ,     IAT  /.
end if
;-----------------------------------

struct IMAGE_DELAY_IMPORT_DESCRIPTOR  ;    -
  Attributes           dd  0
  Name                 dd  0
  ModuleHandle         dd  0
  DelayAddrTable       dd  0
  DelayNameTable       dd  0
  DelayBoundTable      dd  0
  DelayUnloadTable     dd  0
  TimeStamp            dd  0
ends

struct IMAGE_BOUND_IMPORT_DESCRIPTOR
  TimeDateStamp        dd  0 
  OffsetModuleName     dw  0
  ForwarderRefsCount   dw  0
ends

;//------------------------------

struct EXPORT_TABLE
  Flags                dd  0   ; 00
  TimeStamp            dd  0   ; 04  
  Version              dd  0   ; 08
  NameRVA              dd  0   ; 12    (exe/dll)
  OrdinalBase          dd  0   ; 16
  NumOfFunction        dd  0   ; 20    
  NumOfName            dd  0   ; 24      
  AddressOfFunc        dd  0   ; 28     
  AddressOfName        dd  0   ; 32     
  AddressOfOrdinal     dd  0   ; 36     
ends

;//------------------------------

struct RESOURCE_DIR_TABLE
  Flags                dd  0
  TimeStamp            dd  0
  Version              dd  0
  NameEntriesCount     dw  0
  IdEntriesCount       dw  0
ends

struct RESOURCE_ENTRIES
  NameRva              dd  0
  Id                   dd  0
  DataEntryRva         dd  0
  SubDirRva            dd  0
ends

struct RESOURCE_DATA_ENTRY
  DataRva              dd  0
  Size                 dd  0
  CodePage             dd  0
  Reserved             dd  0
ends

struct RESOURCE_STRING
  Length               dw  0
  UnicodeString        du  ?
ends

struct FIXUP_TABLE
  PageRVA              dd  0
  BlockSize            dd  0
  RecordOffset         dw  0
ends

struct TLS_DIR_TABLE
  StartBlockVA         dd  0
  EndBlockVA           dd  0
  IndexVA              dd  0
  CallBackTableVA      dd  0
  SizeOfZero           dd  0
  Characteristics      dd  0  ;//  [23:20]   ,  
ends

;// TLS_CALLBACK ( DllHandle, Reason, Reserved );

struct DEBUG_DIR
  Characteristics      dd  0
  TimeDataStamp        dd  0
  Version              dd  0
  Type                 dd  0
  SizeOfData           dd  0
  AddrOfRawData        dd  0
  PointerToRawData     dd  0
ends

IMAGE_DEBUG_TYPE_UNKNOWN       =  0
IMAGE_DEBUG_TYPE_COFF          =  1
IMAGE_DEBUG_TYPE_CODEVIEW      =  2
IMAGE_DEBUG_TYPE_FPO           =  3  ; Frame Pointer Omission (FPO) information.
IMAGE_DEBUG_TYPE_MISC          =  4
IMAGE_DEBUG_TYPE_EXCEPTION     =  5
IMAGE_DEBUG_TYPE_FIXUP         =  6
IMAGE_DEBUG_TYPE_OMAP_TO_SRC   =  7
IMAGE_DEBUG_TYPE_OMAP_FROM_SRC =  8
IMAGE_DEBUG_TYPE_BORLAND       =  9

FRAME_FPO   = 0
FRAME_TRAP  = 1
FRAME_TSS   = 2

struct FPO_DATA
   ulOffStart     dd  0  ; // offset 1st byte of function code
   cbProcSize     dd  0  ; // # bytes in function
   cdwLocals      dd  0  ; // # bytes in locals/4
   cdwParams      dw  0  ; // # bytes in params/4
   cbProlog       dw  0   
ends








;//****************************
;// Machine Types

IMAGE_FILE_MACHINE_ALPHA      = 0x0184    ;//
IMAGE_FILE_MACHINE_ALPHA64    = 0x0284    ;//
IMAGE_FILE_MACHINE_AM33       = 0x01d3    ;// Mitsushita
IMAGE_FILE_MACHINE_AMD64      = 0x8664    ;//<------------ AMD x86 64-bit
IMAGE_FILE_MACHINE_ARM        = 0x01c0    ;//
IMAGE_FILE_MACHINE_ARM64      = 0xAA64    ;//
IMAGE_FILE_MACHINE_ARMNT      = 0x01c4    ;//
IMAGE_FILE_MACHINE_AXP64      = 0x0284    ;//
IMAGE_FILE_MACHINE_CEE        = 0xC0EE    ;// - MSIL
IMAGE_FILE_MACHINE_CEF        = 0x0CEF    ;//
IMAGE_FILE_MACHINE_EBC        = 0x0EBC    ;// - EFI
IMAGE_FILE_MACHINE_I386       = 0x014c    ;//<------------ Intel 386 or later
IMAGE_FILE_MACHINE_IA64       = 0x0200    ;//
IMAGE_FILE_MACHINE_M32R       = 0x9041    ;// Mitsubishi little endian
IMAGE_FILE_MACHINE_M68K       = 0x0268    ;//
IMAGE_FILE_MACHINE_MIPS16     = 0x0266    ;//
IMAGE_FILE_MACHINE_MIPSFPU    = 0x0366    ;//
IMAGE_FILE_MACHINE_MIPSFPU16  = 0x0466    ;//
IMAGE_FILE_MACHINE_POWERPC    = 0x01f0    ;// Power-PC
IMAGE_FILE_MACHINE_POWERPCFP  = 0x01f1    ;//
IMAGE_FILE_MACHINE_R10000     = 0x0168    ;// MIPS
IMAGE_FILE_MACHINE_R3000      = 0x0162    ;//
IMAGE_FILE_MACHINE_R4000      = 0x0166    ;//
IMAGE_FILE_MACHINE_SH3        = 0x01a2    ;// Hitachi
IMAGE_FILE_MACHINE_SH3DSP     = 0x01a3    ;//
IMAGE_FILE_MACHINE_SH3E       = 0x01a4    ;//
IMAGE_FILE_MACHINE_SH4        = 0x01a6    ;//
IMAGE_FILE_MACHINE_SH5        = 0x01a8    ;//
IMAGE_FILE_MACHINE_THUMB      = 0x01c2    ;//
IMAGE_FILE_MACHINE_TRICORE    = 0x0520    ;// 
IMAGE_FILE_MACHINE_UNKNOWN    = 0x0000    ;//
IMAGE_FILE_MACHINE_WCEMIPSV2  = 0x0169    ;//

;// Characteristics

IMAGE_FILE_16BIT_MACHINE        = 0x0040   ;// Use of this flag is reserved for future use.
IMAGE_FILE_32BIT_MACHINE        = 0x0100   ;// Machine based on 32-bit-word architecture.
IMAGE_FILE_AGGRESSIVE_WS_TRIM   = 0x0010   ;// Aggressively trim working set.
IMAGE_FILE_BYTES_REVERSED_HI    = 0x8000   ;//
IMAGE_FILE_BYTES_REVERSED_LO    = 0x0080   ;// Little endian: LSB precedes MSB in memory.
IMAGE_FILE_DEBUG_STRIPPED       = 0x0200   ;// Debugging information removed from image file.
IMAGE_FILE_DLL                  = 0x2000   ;// The image file is a dynamic-link library (DLL).
IMAGE_FILE_EXECUTABLE_IMAGE     = 0x0002   ;// Indicates that the image file is valid and can be run
IMAGE_FILE_LARGE_ADDRESS_AWARE  = 0x0020   ;// App can handle > 2gb addresses.
IMAGE_FILE_LINE_NUMS_STRIPPED   = 0x0004   ;// COFF line numbers have been removed.
IMAGE_FILE_LOCAL_SYMS_STRIPPED  = 0x0008   ;// COFF symbol table entries for local symbols have been removed.
IMAGE_FILE_RELOCS_STRIPPED      = 0x0001   ;//
IMAGE_FILE_REM_RUN_FROM_SWAP    = 0x0400   ;// If image is on removable media, copy and run from swap file.
IMAGE_FILE_SYSTEM               = 0x1000   ;//
IMAGE_FILE_UP_SYSTEM_ONLY       = 0x4000   ;// File should be run only on a UP machine.


;//---- Subsystem ------------------------

IMAGE_SUBSYSTEM_UNKNOWN                   = 0   ;//  
IMAGE_SUBSYSTEM_NATIVE                    = 1   ;//      Windows
IMAGE_SUBSYSTEM_WINDOWS_GUI               = 2   ;//     (GUI) Windows
IMAGE_SUBSYSTEM_WINDOWS_CUI               = 3   ;//   Windows (CUI)
IMAGE_SUBSYSTEM_OS2_CUI                   = 5   ;//   OS/2
IMAGE_SUBSYSTEM_POSIX_CUI                 = 7   ;//   Posix
IMAGE_SUBSYSTEM_NATIVE_WINDOWS            = 8   ;//   Win9x
IMAGE_SUBSYSTEM_WINDOWS_CE_GUI            = 9   ;// Windows 
IMAGE_SUBSYSTEM_EFI_APPLICATION           = 10  ;//  Extensible Firmware Interface (EFI)
IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER   = 11  ;//  EFI   
IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER        = 12  ;//  EFI    
IMAGE_SUBSYSTEM_EFI_ROM                   = 13  ;//  EFI ROM
IMAGE_SUBSYSTEM_XBOX                      = 14  ;// Xbox
IMAGE_SUBSYSTEM_WINDOWS_BOOT_APPLICATION  = 16  ;//   Windows.

;//----- DLL characteristic --------------

IMAGE_DLLCHARACTERISTICS_HIGH_ENTROPY_VA   = 0x0020  ;// ASLR 64:       (24- ).
IMAGE_DLLCHARACTERISTICS_DYNAMIC_BASE      = 0x0040  ;// ASLR 32:       ( 8- ).
IMAGE_DLLCHARACTERISTICS_FORCE_INTEGRITY   = 0x0080  ;//    .
IMAGE_DLLCHARACTERISTICS_NX_COMPAT         = 0x0100  ;//    NX ( DEP).
IMAGE_DLLCHARACTERISTICS_NO_ISOLATION      = 0x0200  ;//  ,    .
IMAGE_DLLCHARACTERISTICS_NO_SEH            = 0x0400  ;//      (SE).
IMAGE_DLLCHARACTERISTICS_NO_BIND           = 0x0800  ;//   .
IMAGE_DLLCHARACTERISTICS_APPCONTAINER      = 0x1000  ;//     AppContainer.
IMAGE_DLLCHARACTERISTICS_WDM_DRIVER        = 0x2000  ;// WDM-.
IMAGE_DLLCHARACTERISTICS_GUARD_CF          = 0x4000  ;//   Control Flow Guard.
IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER   = 0x8000  ;//    .

;//----------------------------

;// PROD-ID ( Rich-Header)

PidTable:
  dd  @0x0000,@0x0001,@0x0002,@0x0003,@0x0004,@0x0005,@0x0006,@0x0007
  dd 	@0x0008,@0x0009,@0x000a,@0x000b,@0x000c,@0x000d,@0x000e,@0x000f
  dd  @0x0010,@0x0011,@0x0012,@0x0013,@0x0014,@0x0015,@0x0016,@0x0017
  dd  @0x0018,@0x0019,@0x001a,@0x001b,@0x001c,@0x001d,@0x001e,@0x001f
  dd  @0x0020,@0x0021,@0x0022,@0x0023,@0x0024,@0x0025,@0x0026,@0x0027
  dd  @0x0028,@0x0029,@0x002a,@0x002b,@0x002c,@0x002d,@0x002e,@0x002f
  dd  @0x0030,@0x0031,@0x0032,@0x0033,@0x0034,@0x0035,@0x0036,@0x0037
  dd  @0x0038,@0x0039,@0x003a,@0x003b,@0x003c,@0x003d,@0x003e,@0x003f
  dd  @0x0040,@0x0041,@0x0042,@0x0043,@0x0044,@0x0045,@0x0046,@0x0047
  dd  @0x0048,@0x0049,@0x004a,@0x004b,@0x004c,@0x004d,@0x004e,@0x004f
  dd  @0x0050,@0x0051,@0x0052,@0x0053,@0x0054,@0x0055,@0x0056,@0x0057
  dd  @0x0058,@0x0059,@0x005a,@0x005b,@0x005c,@0x005d,@0x005e,@0x005f
  dd  @0x0060,@0x0061,@0x0062,@0x0063,@0x0064,@0x0065,@0x0066,@0x0067
  dd  @0x0068,@0x0069,@0x006a,@0x006b,@0x006c,@0x006d,@0x006e,@0x006f
  dd  @0x0070,@0x0071,@0x0072,@0x0073,@0x0074,@0x0075,@0x0076,@0x0077
  dd  @0x0078,@0x0079,@0x007a,@0x007b,@0x007c,@0x007d,@0x007e,@0x007f
  dd  @0x0080,@0x0081,@0x0082,@0x0083,@0x0084,@0x0085,@0x0086,@0x0087
  dd  @0x0088,@0x0089,@0x008a,@0x008b,@0x008c,@0x008d,@0x008e,@0x008f
  dd  @0x0090,@0x0091,@0x0092,@0x0093,@0x0094,@0x0095,@0x0096,@0x0097
  dd  @0x0098,@0x0099,@0x009a,@0x009b,@0x009c,@0x009d,@0x009e,@0x009f
  dd  @0x00a0,@0x00a1,@0x00a2,@0x00a3,@0x00a4,@0x00a5,@0x00a6,@0x00a7
  dd  @0x00a8,@0x00a9,@0x00aa,@0x00ab,@0x00ac,@0x00ad,@0x00ae,@0x00af
  dd  @0x00b0,@0x00b1,@0x00b2,@0x00b3,@0x00b4,@0x00b5,@0x00b6,@0x00b7
  dd  @0x00b8,@0x00b9,@0x00ba,@0x00bb,@0x00bc,@0x00bd,@0x00be,@0x00bf
  dd  @0x00c0,@0x00c1,@0x00c2,@0x00c3,@0x00c4,@0x00c5,@0x00c6,@0x00c7
  dd  @0x00c8,@0x00c9,@0x00ca,@0x00cb,@0x00cc,@0x00cd,@0x00ce,@0x00cf
  dd  @0x00d0,@0x00d1,@0x00d2,@0x00d3,@0x00d4,@0x00d5,@0x00d6,@0x00d7
  dd  @0x00d8,@0x00d9,@0x00da,@0x00db,@0x00dc,@0x00dd,@0x00de,@0x00df
  dd  @0x00e0,@0x00e1,@0x00e2,@0x00d3,@0x00e4,@0x00e5,@0x00e6,@0x00e7
  dd  @0x00e8,@0x00e9,@0x00ea,@0x00eb,@0x00ec,@0x00ed,@0x00ee,@0x00ef
  dd  @0x00f0,@0x00f1,@0x00f2,@0x00f3,@0x00f4,@0x00f5,@0x00f6,@0x00f7
  dd  @0x00f8,@0x00f9,@0x00fa,@0x00fb,@0x00fc,@0x00fd,@0x00fe,@0x00ff
  dd  @0x0100,@0x0101,@0x0102,@0x0103,@0x0104,@0x0105,@0x0106,@0x0107
  dd  @0x0108,@0x0109,@0x010a,@0x010b,@0x010c,@0x010d,@0x010e

ptSize  = ($-PidTable)/4 

 @0x0000   db   'Unknown',0
	@0x0001   db   'IAT',0
	@0x0002   db   'LINK-5.1',0
	@0x0003   db   'LINK-5.1 OMF to COFF',0
	@0x0004   db   'LINK-6',0
	@0x0005   db   'LINK-6 OMF to COFF',0
	@0x0006   db   'CvtRES to OBJ 5',0
	@0x0007   db   'VisualBasic v11',0
	@0x0008   db   'Visual_C v11',0
	@0x0009   db   'VisualBasic v12',0
	@0x000a   db   'Visual_C   v12',0
	@0x000b   db   'Visual_C++ v12',0
	@0x000c   db   'Symbol Alias LINK-6',0
	@0x000d   db   'VisualBasic v6',0
	@0x000e   db   'MASM-6.13',0
	@0x000f   db   'MASM-7.10',0
	@0x0010   db   'LINK-5.11',0
	@0x0011   db   'LINK-5.11 OMF to COFF',0
	@0x0012   db   'MASM-6.14',0
	@0x0013   db   'LINK-5.12',0
	@0x0014   db   'LINK-5.12 OMF to COFF',0
	@0x0015   db   'Visual_C   Std v12',0
	@0x0016   db   'Visual_C++ Std v12',0
	@0x0017   db   'Visual_C   Book v12',0
	@0x0018   db   'Visual_C++ Book v12',0
	@0x0019   db   'Import Desc LINK-7',0
	@0x001a   db   'LINK-7 OMF to COFF',0
	@0x001b   db   'VisualBasic v13',0
	@0x001c   db   'Visual_C   v13',0
	@0x001d   db   'Visual_C++ v13',0
	@0x001e   db   'LINK-6.10',0
	@0x001f   db   'LINK-6.10 OMF to COFF',0
	@0x0020   db   'LINK-6.01',0
	@0x0021   db   'LINK-6.01 OMF to COFF',0
	@0x0022   db   'VisualBasic v12.10',0
	@0x0023   db   'Visual_C   v12.10',0
	@0x0024   db   'Visual_C++ v12.10',0
	@0x0025   db   'LINK-6.20',0
	@0x0026   db   'LINK-6.20 OMF to COFF',0
	@0x0027   db   'Symbol Alias LINK-7',0
	@0x0028   db   'LINK-6.21',0
	@0x0029   db   'LINK-6.21 OMF to COFF',0
	@0x002a   db   'MASM-6.15',0
	@0x002b   db   'Visual_LTCG_C   v13',0     ;// LTCG (Link-time Code Generation)
	@0x002c   db   'Visual_LTCG_C++ v13',0
	@0x002d   db   'MASM-6.20',0
	@0x002e   db   'ILAsm-1.00',0
	@0x002f   db   'VisualBasic v12.2',0
	@0x0030   db   'Visual_C   v12.2',0
	@0x0031   db   'Visual_C++ v12.2',0
	@0x0032   db   'Visual_C   Std v12.2',0
	@0x0033   db   'Visual_C++ Std v12.2',0
	@0x0034   db   'Visual_C   Book v12.2',0
	@0x0035   db   'Visual_C++ Book v12.2',0
	@0x0036   db   'Import Desc LINK-6.22',0
	@0x0037   db   'LINK-6.22 OMF to COFF',0
	@0x0038   db   'CvtRES to OBJ 5.01',0
	@0x0039   db   'Visual_C   Std v13',0
	@0x003a   db   'Visual_C++ Std v13',0
	@0x003b   db   'Cvtpgd 13',0
	@0x003c   db   'LINK-6.22',0
	@0x003d   db   'LINK-7',0
	@0x003e   db   'Export 6.22',0
	@0x003f   db   'Export 7',0
	@0x0040   db   'MASM-7',0
	@0x0041   db   'Visual_POGO_I_C   v13',0    ;// POGO aka PGO, aka Profile Guided Optimization
	@0x0042   db   'Visual_POGO_I_C++ v13',0
	@0x0043   db   'Visual_POGO_O_C   v13',0
	@0x0044   db   'Visual_POGO_O_C++ v13',0
	@0x0045   db   'CvtRES to OBJ 7',0
	@0x0046   db   'CvtRES to OBJ 7.10p',0
	@0x0047   db   'LINK-7.10p',0
	@0x0048   db   'LINK-7.10p (OMF to COFF)',0
	@0x0049   db   'Export 7.10p',0
	@0x004a   db   'Import Desc LINK-7.10p',0
	@0x004b   db   'MASM-7.10p',0
	@0x004c   db   'Visual_C   v13.10p',0
	@0x004d   db   'Visual_C++ v13.10p',0
	@0x004e   db   'Visual_C   Std v13.10p',0
	@0x004f   db   'Visual_C++ Std v13.10p',0
	@0x0050   db   'Visual_LTCG_C   v13.10p',0
	@0x0051   db   'Visual_LTCG_C++ v13.10p',0
	@0x0052   db   'Visual_POGO_I_C   v13.10p',0
	@0x0053   db   'Visual_POGO_I_C++ v13.10p',0
	@0x0054   db   'Visual_POGO_O_C   v13.10p',0
	@0x0055   db   'Visual_POGO_O_C++ v13.10p',0
	@0x0056   db   'LINK-6.24',0
	@0x0057   db   'LINK-6.24 OMF to COFF',0
	@0x0058   db   'Export 6.24',0
	@0x0059   db   'Import Desc LINK-6.24',0
	@0x005a   db   'LINK-7.10',0
	@0x005b   db   'LINK-7.10 (OMF to COFF)',0
	@0x005c   db   'Export 7.10',0
	@0x005d   db   'Import Desc LINK-7.10',0
	@0x005e   db   'CvtRES to OBJ 7.10',0
	@0x005f   db   'Visual_C   v13.10',0
	@0x0060   db   'Visual_C++ v13.10',0
	@0x0061   db   'Visual_C   Std v13.10',0
	@0x0062   db   'Visual_C++ Std v13.10',0
	@0x0063   db   'Visual_LTCG_C   v13.10',0
	@0x0064   db   'Visual_LTCG_C++ v13.10',0
	@0x0065   db   'Visual_POGO_I_C   v13.10',0
	@0x0066   db   'Visual_POGO_I_C++ v13.10',0
	@0x0067   db   'Visual_POGO_O_C   v13.10',0
	@0x0068   db   'Visual_POGO_O_C++ 13.10',0
	@0x0069   db   'Symbol Alias LINK-7.10',0
	@0x006a   db   'Symbol Alias LINK-7.10p',0
	@0x006b   db   'Cvtpgd 13.10',0
	@0x006c   db   'Cvtpgd 13.10p',0
	@0x006d   db   'Visual_C   v14',0
	@0x006e   db   'Visual_C++ v14',0
	@0x006f   db   'Visual_C   Std v14',0
	@0x0070   db   'Visual_C++ Std v14',0
	@0x0071   db   'Visual_LTCG_C   v14',0
	@0x0072   db   'Visual_LTCG_C++ v14',0
	@0x0073   db   'Visual_POGO_I_C   v14',0
	@0x0074   db   'Visual_POGO_I_C++ v14',0
	@0x0075   db   'Visual_POGO_O_C   v14',0
	@0x0076   db   'Visual_POGO_O_C++ v14',0
	@0x0077   db   'Cvtpgd v14',0
	@0x0078   db   'LINK-8',0
	@0x0079   db   'LINK-8 OMF to COFF',0
	@0x007a   db   'Export 8',0
	@0x007b   db   'Import Desc LINK-8',0
	@0x007c   db   'CvtRES to OBJ 8',0
	@0x007d   db   'MASM-8',0
	@0x007e   db   'Symbol Alias LINK-8',0
	@0x007f   db   'PhoenixPrerelease',0
	@0x0080   db   'Visual_CVTCIL_C   14.0',0
	@0x0081   db   'Visual_CVTCIL_C++ 14.0',0
	@0x0082   db   'Visual_LTCG_MSIL  14.0',0
	@0x0083   db   'Visual_C   v15',0
	@0x0084   db   'Visual_C++ v15',0
	@0x0085   db   'Visual_C   Std v15',0
	@0x0086   db   'Visual_C++ Std v15',0
	@0x0087   db   'Visual_CVTCIL_C   v15',0
	@0x0088   db   'Visual_CVTCIL_C++ v15',0
	@0x0089   db   'Visual_LTCG_C   v15',0
	@0x008a   db   'Visual_LTCG_C++ v15',0
	@0x008b   db   'Visual_LTCG_MSIL v15',0
	@0x008c   db   'Visual_POGO_I_C   v15',0
	@0x008d   db   'Visual_POGO_I_C++ v15',0
	@0x008e   db   'Visual_POGO_O_C   v15',0
	@0x008f   db   'Visual_POGO_O_C++ v15',0
	@0x0090   db   'Cvtpgd 15',0
	@0x0091   db   'LINK-9',0
	@0x0092   db   'Export 9',0
	@0x0093   db   'Import Desc LINK-9',0
	@0x0094   db   'CvtRES to OBJ 9',0
	@0x0095   db   'MASM-9',0
	@0x0096   db   'Symbol Alias LINK-9',0
	@0x0097   db   'CvtRES to OBJ',0
	@0x0098   db   'Symbol Alias LINK-10',0
	@0x0099   db   'Cvtpgd 16',0
	@0x009a   db   'CvtRES to OBJ 10',0
	@0x009b   db   'Export 10',0
	@0x009c   db   'Import Desc LINK-10',0
	@0x009d   db   'LINK-10',0
	@0x009e   db   'MASM-10',0
	@0x009f   db   'Phx1600_C',0
	@0x00a0   db   'Phx1600_C++',0
	@0x00a1   db   'Phx1600_CVTCIL_C',0
	@0x00a2   db   'Phx1600_CVTCIL_C++',0
	@0x00a3   db   'Phx1600_LTCG_C',0
	@0x00a4   db   'Phx1600_LTCG_C++',0
	@0x00a5   db   'Phx1600_LTCG_MSIL',0
	@0x00a6   db   'Phx1600_POGO_I_C',0
	@0x00a7   db   'Phx1600_POGO_I_C++',0
	@0x00a8   db   'Phx1600_POGO_O_C',0
	@0x00a9   db   'Phx1600_POGO_O_C++',0
	@0x00aa   db   'Visual_C   v16',0
	@0x00ab   db   'Visual_C++ v16',0
	@0x00ac   db   'Visual_CVTCIL_C   v16',0
	@0x00ad   db   'Visual_CVTCIL_C++ v16',0
	@0x00ae   db   'Visual_LTCG_C    v16',0
	@0x00af   db   'Visual_LTCG_C++  v16',0
	@0x00b0   db   'Visual_LTCG_MSIL v16',0
	@0x00b1   db   'Visual_POGO_I_C   v16',0
	@0x00b2   db   'Visual_POGO_I_C++ v16',0
	@0x00b3   db   'Visual_POGO_O_C   v16',0
	@0x00b4   db   'Visual_POGO_O_C++ v16',0
	@0x00b5   db   'Symbol Alias LINK-10.10',0
	@0x00b6   db   'Cvtpgd 16.10',0
	@0x00b7   db   'CvtRES to OBJ 10.10',0
	@0x00b8   db   'Export 10.10',0
	@0x00b9   db   'Import Desc LINK-10.10',0
	@0x00ba   db   'LINK-10.10',0
	@0x00bb   db   'MASM-10.10',0
	@0x00bc   db   'Visual_C   v16.10',0
	@0x00bd   db   'Visual_C++ v16.10',0
	@0x00be   db   'Visual_CVTCIL_C   v16.10',0
	@0x00bf   db   'Visual_CVTCIL_C++ v16.10',0
	@0x00c0   db   'Visual_LTCG_C   v16.10',0
	@0x00c1   db   'Visual_LTCG_C++ v16.10',0
	@0x00c2   db   'Visual_LTCG_MSIL v16.10',0
	@0x00c3   db   'Visual_POGO_I_C   v16.10',0
	@0x00c4   db   'Visual_POGO_I_C++ v16.10',0
	@0x00c5   db   'Visual_POGO_O_C   v16.10',0
	@0x00c6   db   'Visual_POGO_O_C++ v16.10',0
	@0x00c7   db   'Symbol Alias LINK-11',0
	@0x00c8   db   'Cvtpgd 17',0
	@0x00c9   db   'CvtRES to OBJ 11',0
	@0x00ca   db   'Export 11',0
	@0x00cb   db   'Import Desc LINK-11',0
	@0x00cc   db   'LINK-11',0
	@0x00cd   db   'MASM-11',0
	@0x00ce   db   'Visual_C   v17',0
	@0x00cf   db   'Visual_C++ v17',0
	@0x00d0   db   'Visual_CVTCIL_C   v17',0
	@0x00d1   db   'Visual_CVTCIL_C++ v17',0
	@0x00d2   db   'Visual_LTCG_C   v17',0
	@0x00d3   db   'Visual_LTCG_C++ v17',0
	@0x00d4   db   'Visual_LTCG_MSIL v17',0
	@0x00d5   db   'Visual_POGO_I_C   v17',0
	@0x00d6   db   'Visual_POGO_I_C++ v17',0
	@0x00d7   db   'Visual_POGO_O_C   v17',0
	@0x00d8   db   'Visual_POGO_O_C++ v17',0
	@0x00d9   db   'Symbol Alias LINK-12',0
	@0x00da   db   'Cvtpgd 18',0
	@0x00db   db   'CvtRES to OBJ 12',0
	@0x00dc   db   'Export 12',0
	@0x00dd   db   'Import Desc LINK-12',0
	@0x00de   db   'LINK-12',0
	@0x00df   db   'MASM-12',0
	@0x00e0   db   'Visual_C   v18',0
	@0x00e1   db   'Visual_C++ v18',0
	@0x00e2   db   'Visual_CVTCIL_C   v18',0
	@0x00e3   db   'Visual_CVTCIL_C++ v18',0
	@0x00e4   db   'Visual_LTCG_C   v18',0
	@0x00e5   db   'Visual_LTCG_C++ v18',0
	@0x00e6   db   'Visual_LTCG_MSIL v18',0
	@0x00e7   db   'Visual_POGO_I_C   v18',0
	@0x00e8   db   'Visual_POGO_I_C++ v18',0
	@0x00e9   db   'Visual_POGO_O_C   v18',0
	@0x00ea   db   'Visual_POGO_O_C++ v18',0
	@0x00eb   db   'Symbol Alias LINK-12.10',0
	@0x00ec   db   'Cvtpgd 18.10',0
	@0x00ed   db   'CvtRES to OBJ 12.10',0
	@0x00ee   db   'Export 12.10',0
	@0x00ef   db   'Import Desc LINK-12.10',0
	@0x00f0   db   'LINK-12.10',0
	@0x00f1   db   'MASM-12.10',0
	@0x00f2   db   'Visual_C   v18.1',0
	@0x00f3   db   'Visual_C++ v18.1',0
	@0x00f4   db   'Visual_CVTCIL_C   v18.1',0
	@0x00f5   db   'Visual_CVTCIL_C++ v18.1',0
	@0x00f6   db   'Visual_LTCG_C   v18.1',0
	@0x00f7   db   'Visual_LTCG_C++ v18.1',0
	@0x00f8   db   'Visual_LTCG_MSIL v18.1',0
	@0x00f9   db   'Visual_POGO_I_C   v18.1',0
	@0x00fa   db   'Visual_POGO_I_C++ v18.1',0
	@0x00fb   db   'Visual_POGO_O_C   v18.1',0
	@0x00fc   db   'Visual_POGO_O_C++ v18.1',0
	@0x00fd   db   'Symbol Alias LINK-14',0
	@0x00fe   db   'Cvtpgd-19',0
	@0x00ff   db   'CvtRES to OBJ 14',0
	@0x0100   db   'Export 14',0
	@0x0101   db   'Import Desc LINK-14',0
	@0x0102   db   'LINK-14',0
	@0x0103   db   'MASM-14',0
	@0x0104   db   'Visual_C   v19',0
	@0x0105   db   'Visual_C++ v19',0
	@0x0106   db   'Visual_CVTCIL_C   v19',0
	@0x0107   db   'Visual_CVTCIL_C++ v19',0
	@0x0108   db   'Visual_LTCG_C   v19',0
	@0x0109   db   'Visual_LTCG_C++ v19',0
	@0x010a   db   'Visual_LTCG_MSIL v19',0
	@0x010b   db   'Visual_POGO_I_C   v19',0
	@0x010c   db   'Visual_POGO_I_C++ v19',0
	@0x010d   db   'Visual_POGO_O_C   v19',0
	@0x010e   db   'Visual_POGO_O_C++ v19',0





